/***************************************************************
 * Part     : W`t@C
 * Author   : 2019/01/14	nauzou
 */

#pragma	once

#include <stdbool.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>

/********************************************************************
		eݒ
********************************************************************/
/*---------------------------------------------------------
  @CPU NbN
---------------------------------------------------------*/
#define	__CLOCK_CPU__		(16000000)		/* 16MHz		*/

/********************************************************************
		^錾
********************************************************************/
/*---------------------------------------------------------
  @^
---------------------------------------------------------*/
typedef	signed long long	llong;

typedef	signed char			int8;
typedef	signed short		int16;
typedef	signed long			int32;
typedef	signed long long	int64;
/*---------------------------------------------------------
  @^
---------------------------------------------------------*/
typedef	unsigned int		uint;
typedef	unsigned char		uchar;
typedef	unsigned short		ushort;
typedef	unsigned long		ulong;
typedef	unsigned long long	ullong;

typedef	unsigned char		uint8;
typedef	unsigned short		uint16;
typedef	unsigned long		uint32;
typedef	unsigned long long	uint64;

/********************************************************************
		CC֐
********************************************************************/
/*---------------------------------------------------------
  @荞ݐ
---------------------------------------------------------*/
#if defined(__AVR__)
#define	IRQ_ENABLE	(true)
#define	IRQ_DISABLE	(false)
typedef	bool	INTFLG;

static inline INTFLG
irq_flg()
{
	return (SREG & 0x80) != 0;
}

static inline INTFLG
irq_disable()
{
	volatile INTFLG	ret;
	
	ret = irq_flg();
	cli();
	
	return ret;
}

static inline void
irq_enable( INTFLG flags )	/* flags != IRQ_DISABLE őS	*/
{
	if( flags != IRQ_DISABLE )
		sei();
	else
		cli();
}
#endif
