/***************************************************************
 * Part     : USART ʐMhCo[
 * Author   : 2019/01/14	nauzou
 */

#include <stdio.h>
#include "usart.h"

/********************************************************************
		[Jϐ
********************************************************************/
/*---------------------------------------------------------
  @M FIFO Ǘnh
---------------------------------------------------------*/
static FIFOBUF		send_buf;						/* Mp	*/
static FIFOBUF		recv_buf;						/* Mp	*/
/*---------------------------------------------------------
  @M FIFO ̃obt@{
---------------------------------------------------------*/
static uint8		_send_buf[USART_MAX_SEND_BUF];	/* Mp	*/
static uint8		_recv_buf[USART_MAX_RECV_BUF];	/* Mp	*/

/********************************************************************
		X^eBbN֐̃vg^Cv錾
********************************************************************/
static void		rx_int( void );
static void		txe_int( void );

/********************************************************************
		荞݃xN^
********************************************************************/
ISR(USART_RX_vect)		{rx_int();}				/* USARTEM荞						*/
ISR(USART_UDRE_vect)	{txe_int();}			/* ..   EMf[^WX^󂫊荞	*/
ISR(USART_TX_vect)		{/*gp*/}			/* ..   EM荞					*/

/********************************************************************
		荞ݏ֐
********************************************************************/
/*---------------------------------------------------------
 * Function :
 *  @M荞ݏsB
 */
static void
rx_int()
{
	/* Mf[^ FIFO obt@ɓiobt@󂢂ĂȂǂݎ̂āj	*/
	fifo_add( &recv_buf,UDR0 );
}
/*---------------------------------------------------------
 * Function :
 *  @Mf[^WX^󂫊荞ݏsB
 */
static void
txe_int()
{
	uint8	c;
	
	/* Mf[^ FIFO obt@o	*/
	if( !fifo_get( &send_buf,&c ) ) {
		/* Mf[^Ȃ̂Ŋ荞݂֎~	*/
		UCSR0B &= ~(1 << UDRIE0);
	} else {
		/* f[^𑗐M	*/
		UDR0 = c;
	}
}

/********************************************************************
		ʊ֐
********************************************************************/
/*---------------------------------------------------------
 * Function :
 *  @USART ̏sB
 */
void
init_usart()
{
	uint16	rate;
	INTFLG	iflag;
	
	/* ݒ蒆͊荞݂֎~	*/
	iflag = irq_disable();
	
	/* Mobt@	*/
	fifo_init( &send_buf,_send_buf,sizeof(_send_buf) );
	fifo_init( &recv_buf,_recv_buf,sizeof(_recv_buf) );
	
	/* ʐMx UBRR0H/L ̐ݒliU2X0 ̒lǂ邩́AۂɌvZĂ݂Č덷̏Ȃɂ̂𐄏j	*/
	rate = (uint16)((__CLOCK_CPU__ / 16 / BAUD_RATE) - 1);	/* U2X0 = 0 	*/
//	rate = (uint16)((__CLOCK_CPU__ /  8 / BAUD_RATE) - 1);	/* U2X0 = 1 	*/
	
	/* e탌WX^ݒiڍׂ usart.h QƁj	*/
	UBRR0H = (uint8)(rate >> 8);
	UBRR0L = (uint8)(rate & 0xff);
	UCSR0A = (0 << TXC0)    | (0 << U2X0)    | (0 << MPCM0);
	UCSR0C = (0 << UMSEL01) | (0 << UMSEL00) | (0 << UPM01)  | (0 << UPM00) | (0 << USBS0) | (1 << UCSZ01) | (1 << UCSZ00) | (0 << UCPOL0);
	UCSR0B = (1 << RXCIE0)  | (0 << TXCIE0)  | (0 << UDRIE0) | (1 << RXEN0) | (1 << TXEN0) | (0 << UCSZ02) | (0 << TXB80);
	
	/* 荞݃tO𕜋A	*/
	irq_enable( iflag );
}
/*---------------------------------------------------------
 * Function :
 *  @M҂f[^𓾂B
 *
 * Return :
 *  @M҂̃f[^ԂB
 */
uint8
usart_recv_rest()
{
	return fifo_data_num( &recv_buf );
}
/*---------------------------------------------------------
 * Function :
 *  @M҂f[^𓾂B
 *
 * Return :
 *  @M҂̃f[^ԂB
 */
uint8
usart_send_rest()
{
	return fifo_data_num( &send_buf );
}
/*---------------------------------------------------------
 * Function :
 *  @ŵP𑗐MB
 *
 * Arguments :
 *		data	: Mf[^
 *
 * Note :
 *  @f[^𑗐Mp FIFO obt@ɓ܂ŏ
 *  ߂Ȃ̂ŒӂĉB
 */
void
usart_putc( char data )
{
	bool	add_flg;
	
	/* Mp FIFO obt@ɓ܂Ń[v	*/
	while( 1 ) {
		/* Mf[^ FIFO ɓ	*/
		add_flg = fifo_add( &send_buf,(uint8)data );
		
		/* Mf[^WX^󂫊荞݂Lɂ	*/
		UCSR0B |= (1 << UDRIE0);
		
		/* Mf[^ FIFO ɓꂽI	*/
		if( add_flg )
			return;
	}
}
/*---------------------------------------------------------
 * Function :
 *  @PMB
 *
 * Return :
 *  @MԂB
 *
 * Note :
 *  @f[^M܂ŏ߂Ȃ̂ŕKvȂ
 *  O usart_recv_rest() ŎMf[^邱Ƃ
 *  mFĂĂяoĉB
 */
char
usart_getc()
{
	uint8	ret;
	
	/* Mp FIFO obt@f[^o܂Ń[v	*/
	while( !fifo_get( &recv_buf,&ret ) )
		;	/* Ȃ	*/
	
	return (char)ret;
}
/*---------------------------------------------------------
 * Function :
 *  @𑗐MB
 *
 * Arguments :
 *		str		: M镶
 *
 * Note :
 *  @𑗐Mp FIFO obt@ɓ܂ŏ
 *  ߂Ȃ̂ŒӂĉB
 */
#if ENABLE_USART_PUTS || ENABLE_USART_PRINTF
/* str  SRAM ̈p	*/
void
usart_puts( const char *str )
{
	for( ; *str != '\0' ; str++ )
		usart_putc( *str );
}

/* str  Prog FLASH ̈p	*/
void
usart_puts_p( const char *str )
{
	for( ; pgm_read_byte(str) != '\0' ; str++ )
		usart_putc( pgm_read_byte(str) );
}
#endif
/*---------------------------------------------------------
 * Function :
 *  @MB
 *
 * Arguments :
 *		str		: Mi[obt@
 *
 * Note :
 *  @䕶 BS(0x08) ̂ݑΉ̊ȈՔłłB
 *  @obt@A_[̃`FbN͂Ă܂A
 *  obt@I[o[̃`FbN͂Ă܂B
 *  @DELIMITER_CHAR M܂ŏ߂Ȃ̂
 *  ӂĉB
 */
#if ENABLE_USART_GETS
void
usart_gets( char *buf )
{
	char	*p,chr;
	
	p = buf;
	while( 1 ) {
		chr = usart_getc();
		switch( chr ) {
		  case	DELIMITER_CHAR:
		  	*p = '\0';
		  	return;
#if ENABLE_USART_GETS_BACK_SPACE
		  case	0x08:		/* obNXy[X	*/
		  	if( p > buf )
		  		p--;
		  	break;
#endif
		  default:
		  	*p = chr;
		  	p++;
		  	break;
		}
	}
}
#endif
/*---------------------------------------------------------
 * Function :
 *  @w̏ɏ]ĕ𑗐MB
 *
 * Arguments :
 *		form	: M镶̏
 *		arg		: M镶̏̈
 *		...		: ..
 *
 * Note :
 *  @𑗐Mp FIFO obt@ɓ܂ŏ
 *  ߂Ȃ̂ŒӂĉB
 */
#if ENABLE_USART_PRINTF
/* form  SRAM ̈p va_list 	*/
void
usart_vprintf( const char *form,va_list arg )
{
	char	buf[USART_MAX_STR];
	
	vsnprintf( buf,sizeof(buf),form,arg );
	usart_puts( buf );
}

/* form  Prog FLASH ̈p va_list 	*/
void
usart_vprintf_p( const char *form,va_list arg )
{
	char	buf[USART_MAX_STR];
	
	vsnprintf_P( buf,sizeof(buf),form,arg );
	usart_puts( buf );
}

/* form  SRAM ̈p̉ϒ	*/
void
usart_printf( const char *form,... )
{
	va_list	arg;
	
	va_start( arg,form );
	usart_vprintf( form,arg );
	va_end( arg );
}

/* form  Prog FLASH ̈p̉ϒ	*/
void
usart_printf_p( const char *form,... )
{
	va_list	arg;
	
	va_start( arg,form );
	usart_vprintf_p( form,arg );
	va_end( arg );
}
#endif
